package kr.co.vividnext.sodalive.admin.statistics.member

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/member/statistics")
class AdminMemberStatisticsController(private val service: AdminMemberStatisticsService) {
    @GetMapping
    fun getStatistics(
        @RequestParam startDateStr: String,
        @RequestParam endDateStr: String,
        pageable: Pageable
    ) = ApiResponse.ok(
        service.getStatistics(
            startDateStr = startDateStr,
            endDateStr = endDateStr,
            pageable = pageable
        )
    )
}
