package kr.co.vividnext.sodalive.audition.role

import com.querydsl.core.annotations.QueryProjection

data class GetAuditionRoleDetailResponse(
    val auditionRoleId: Long,
    val name: String,
    val imageUrl: String,
    val information: String,
    val originalWorkUrl: String,
    val auditionScriptUrl: String,
    val isAlreadyApplicant: Boolean = false
)

data class GetAuditionRoleDetailData @QueryProjection constructor(
    val auditionRoleId: Long,
    val name: String,
    val imageUrl: String,
    val information: String,
    val originalWorkUrl: String,
    val auditionScriptUrl: String
) {
    fun toDetailResponse(isAlreadyApplicant: Boolean) = GetAuditionRoleDetailResponse(
        auditionRoleId = auditionRoleId,
        name = name,
        imageUrl = imageUrl,
        information = information,
        originalWorkUrl = originalWorkUrl,
        auditionScriptUrl = auditionScriptUrl,
        isAlreadyApplicant = isAlreadyApplicant
    )
}
