package kr.co.vividnext.sodalive.audition.vote

import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.common.SodaException
import kr.co.vividnext.sodalive.member.Member
import org.springframework.security.core.annotation.AuthenticationPrincipal
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/audition/vote")
class AuditionVoteController(
    private val service: AuditionVoteService
) {
    @PostMapping
    fun voteAuditionApplicant(
        @RequestBody request: VoteAuditionApplicantRequest,
        @AuthenticationPrincipal(expression = "#this == 'anonymousUser' ? null : member") member: Member?
    ) = run {
        if (member == null) throw SodaException("로그인 정보를 확인해주세요.")

        ApiResponse.ok(
            service.voteAuditionApplicant(
                applicantId = request.applicantId,
                timezone = request.timezone,
                container = request.container,
                member = member
            )
        )
    }
}
