package kr.co.vividnext.sodalive.creator.admin.content.series

import kr.co.vividnext.sodalive.content.AudioContent
import java.time.LocalDateTime
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.GeneratedValue
import javax.persistence.GenerationType
import javax.persistence.Id
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.PrePersist

@Entity
class SeriesContent {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long? = null

    var orders: Int = 1

    var createdAt: LocalDateTime? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "series_id", nullable = false)
    var series: Series? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "content_id", nullable = false)
    var content: AudioContent? = null

    @PrePersist
    fun prePersist() {
        createdAt = LocalDateTime.now()
    }
}
