package kr.co.vividnext.sodalive.event

import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonProperty
import com.querydsl.core.annotations.QueryProjection

data class GetEventResponse(
    @JsonProperty("totalCount") val totalCount: Int,
    @JsonProperty("eventList") val eventList: List<EventItem>
)

@JsonIgnoreProperties(ignoreUnknown = true)
data class EventItem @QueryProjection constructor(
    @JsonProperty("id") val id: Long,
    @JsonProperty("thumbnailImageUrl") var thumbnailImageUrl: String,
    @JsonProperty("detailImageUrl") var detailImageUrl: String? = null,
    @JsonProperty("popupImageUrl") var popupImageUrl: String? = null,
    @JsonProperty("link") val link: String? = null
)
