package kr.co.vividnext.sodalive.member.notification

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.member.notification.QMemberNotification.memberNotification
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface MemberNotificationRepository : JpaRepository<MemberNotification, Long>, MemberNotificationQueryRepository

interface MemberNotificationQueryRepository {
    fun getMemberNotification(memberId: Long): MemberNotification?
}

@Repository
class MemberNotificationQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : MemberNotificationQueryRepository {
    override fun getMemberNotification(memberId: Long): MemberNotification? {
        return queryFactory
            .selectFrom(memberNotification)
            .where(memberNotification.member.id.eq(memberId))
            .fetchFirst()
    }
}
