package kr.co.vividnext.sodalive.member.notification

import kr.co.vividnext.sodalive.member.Member
import org.springframework.stereotype.Service

@Service
class MemberNotificationService(private val repository: MemberNotificationRepository) {
    fun updateNotification(
        live: Boolean? = null,
        uploadContent: Boolean? = null,
        message: Boolean? = null,
        audition: Boolean? = null,
        member: Member
    ) {
        var notification = repository.getMemberNotification(memberId = member.id!!)
        if (notification == null) {
            notification = MemberNotification(
                uploadContent = uploadContent ?: false,
                live = live ?: false,
                message = message ?: false,
                audition = audition ?: false
            )
            notification.member = member
            repository.save(notification)
        } else {
            if (live != null) notification.live = live
            if (message != null) notification.message = message
            if (audition != null) notification.audition = audition
            if (uploadContent != null) notification.uploadContent = uploadContent
        }
    }
}
