package kr.co.vividnext.sodalive.member.signUp

import org.springframework.stereotype.Component

@Component
class SignUpValidator {
    fun emailValidation(email: String): String {
        val isNotValidEmail = "^[A-Z0-9._%+-]+@[A-Z0-9.-]+\\.[A-Z]{2,6}$"
            .toRegex(RegexOption.IGNORE_CASE)
            .matches(email)
            .not()

        if (isNotValidEmail) {
            return "올바른 이메일을 입력해 주세요"
        }

        return ""
    }

    fun nicknameValidation(nickname: String): String {
        if (nickname.trim().length < 2) {
            return "닉네임은 2자 이상 입력해 주세요."
        }

        return ""
    }

    fun passwordValidation(password: String): String {
        val isNotValidPassword = "^(?=.*[A-Za-z])(?=.*\\d)[A-Za-z\\d$@!%*#?&]{8,}$"
            .toRegex()
            .matches(password)
            .not()

        if (isNotValidPassword) {
            return "영문, 숫자 포함 8자 이상의 비밀번호를 입력해 주세요."
        }

        return ""
    }
}
